#Server script to get stream of images and display the stream

from socket import socket, gethostbyname, AF_INET, SOCK_DGRAM, SOCK_STREAM
import sys,cv2
import numpy as np

#init variables
SERVER_IP = '192.168.4.188'
PORT_NUMBER = 5000
SIZE = 2048
ACK = "ack"
hostName = gethostbyname( '0.0.0.0' )
MAX_SIZE = 1448

#set the socket and bind to the client
mySocket = socket(AF_INET, SOCK_STREAM)
mySocket.bind((hostName, PORT_NUMBER))

print ("Server listening on port {0}\n".format(PORT_NUMBER))
mySocket.listen(5)

#establish connection to the socket
c, addr = mySocket.accept()
print( " got connection from", addr)

while True:
    	print c
        #init message bytearray
	msg = bytearray()
        
        #open an image to write recieved data
        f = open('torecv.png','wb')
	print('waiting for image size data')
	ack = c.recv(10)
	print ('size recived')
	size = int(ack.decode())
	#send ack back
	c.send(bytes(1))
	
	print("start reciving image")
        factor = size/MAX_SIZE
	#get image data. If data is more than MAX_SIZE recieve in batches. 
	if size <= MAX_SIZE:
		l = c.recv(size)
		print l
	else:
		for i in range(factor):
			l = c.recv(1448)
                        msg.extend(l)

		if size%1448 > 0:
			l = c.recv(size)
			msg.extend(l)				
	
	#write the image data
	f.write(msg)
	f.close()
	print("image recieved")
	# after recieving and storing the image, open the image in a new window
	img = cv2.imread('torecv.png',1)
        cv2.imshow('image',img)
        #wait for a bit to display the image
        k = cv2.waitKey(1)
        if k == 27:
            # wait for ESC key to exit
            cv2.destroyAllWindows()
        	
print ("closing socket")
c.close()


sys.exit()
