#Client script to get image from V-REP and send the images to a socket

import vrep 
import sys,cv2,Image,time
import numpy as np
from socket import socket, AF_INET, SOCK_DGRAM, SOCK_STREAM, gethostbyname


print 'Program started'

SERVER_IP   = '192.168.4.69'
PORT_NUMBER = 5000
SIZE = 1024
time.sleep(1)
mySocket = socket( AF_INET, SOCK_STREAM )
mySocket.connect((SERVER_IP,PORT_NUMBER))



# open the image and read the data. Send the size of the image first.
f = open('/home/vishak/cv/mexopencv/position.png','rb')
img_data = f.read()
size = len(img_data)
                        
#send size to client and wait for reciving ack
mySocket.sendto(bytes(size),(SERVER_IP,PORT_NUMBER))
print ('waiting for ack')
ack = mySocket.recv(1)
          
if(1 == int(ack.decode())):
    print("got ack")
    #send all of image at once
    mySocket.sendall(img_data)
    print("Image sent")
            
    #cv2.waitKey(1) & 0xFF == ord('q')
        
    
mySocket.close()
print 'Program ended'
